#include "StdAfx.h"

#include "Globals.h"
#include <stdio.h>

void FullHelp()
{
printf("Send - Sends keystrokes and windows messages to applications\n");
printf("\n");
printf("======================================================================\n");
printf("\n");
printf("Usage:    send [-rcflwdhna] [-n NewName] [-s \"Class\"] \"application\" \"keys\" [time]\n");
printf("\n");
printf("\"application\" is a case-insensitive string that matches part of a window\n");
printf("caption.  For example, if you are running notepad, its title bar will be\n");
printf("something similar to \"MyFile.txt - Notepad\".  You could have send.exe type\n");
printf("the text \"Hello\" by using the following command:\n");
printf("\n");
printf("    send notepad Hello\n");
printf("\n");
printf("Spaces in the key string need to be quoted, as in:\n");
printf("\n");
printf("    send notepad \"Hello everyone!\"\n");
printf("    \n");
printf("[time] is a string representation of a time at which you want the keys to\n");
printf("be sent to the application.  The application window need not exist until\n");
printf("that time.  For example, to send the F6 key to VirtualDub at 4:55 PM, use\n");
printf("the following syntax:\n");
printf("\n");
printf("    send virtualdub \\{F6} 4:55pm\n");
printf("\n");
printf("The time string accepts several different time formats (it uses the Windows\n");
printf("function VarDateFromStr), including dates.  Dates with spaces must be\n");
printf("quoted, as in:\n");
printf("\n");
printf("    send virtualdub \\{F6} \"April 1, 2001 10:55am\"\n");
printf("\n");
printf("Options:\n");
printf("\n");
printf("    -r  Uses a regular expression for the search string.  For example,\n");
printf("        \"^notepad$\" would match only a window titled exactly \"Notepad\" and\n");
printf("        not one name \"Untitled - Notepad\".\n");
printf("\n");
printf("    -c  Uses a case-sensitive search, so that \"notepad\" will not match\n");
printf("        \"Notepad\"\n");
printf("\n");
printf("    -l  Lists all of the window captions that \"send\" finds before\n");
printf("        matching the search string.  Useful for discoving the precise\n");
printf("        titles of windows.\n");
printf("\n");
printf("    -f  Sends the specified string to the window repeatedly.  This is most\n");
printf("        useful when the keystrokes you are sending will cause the window to\n");
printf("        close, and you want to send the same keystrokes to the window again\n");
printf("        when it reappears (with the -w options).\n");
printf("        \n");
printf("    -g  Sends the specified string to whichever window happens to be in\n");
printf("        the foreground.  Useful for arbitrary mouse movements that do not\n");
printf("        need a particular window to be focused.  If you specify the \"-g\"\n");
printf("        option, you must still specify a window caption, but it is ignored.\n");
printf("    \n");
printf("    -b  Does not bring the specified window to the foreground.  Keystrokes\n");
printf("        will still be sent to whatever window is in the foreground, but\n");
printf("        you may send windows messages and position/size commands to a\n");
printf("        background window (useful for moving a window without bringing it\n");
printf("        to the foreground first).  Using this option implies -d.\n");
printf("    \n");
printf("    -w  Waits for the window to exist before sending the keystrokes.\n");
printf("\n");
printf("    -d  Disables switching back to the process that launched send.exe\n");
printf("        after sending the input string.\n");
printf("\n");
printf("    -h  Includes hidden windows in the search.  Normally, a nonvisible\n");
printf("        window is not a desired target for input operations.\n");
printf("\n");
printf("    -n  Gives the found window a new caption.  This can be useful when you\n");
printf("        want to send an input string that will take some time to process,\n");
printf("        and then use another \"send\" command to wait for the new window\n");
printf("        caption to exist.\n");
printf("        \n");
printf("    -a  Sends the commands to every window matching the expression, not\n");
printf("        just the first one.\n");
printf("        \n");
printf("    -s  The window must also match the class name provided.\n");
printf("        \n");
printf("\n");
printf("======================================================================\n");
printf("\n");
printf("If you want to send a special key, such as F6 or Escape, use the following\n");
printf("tables (examples are for notepad or other such edit controls):\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Keyboard Modifiers:\n");
printf("    \\a      Press the ALT key\n");
printf("    \\A      Release the ALT key\n");
printf("    \\s      Press the SHIFT key\n");
printf("    \\S      Release the SHIFT key\n");
printf("    \\c      Press the CONTROL key\n");
printf("    \\C      Release the CONTROL key\n");
printf("    \\p      Press the APPLICATIONS key\n");
printf("    \\P      Release the APPLICATIONS key\n");
printf("    \\w      Press the WINDOWS key\n");
printf("    \\W      Release the WINDWOS key\n");
printf("\n");
printf("For example, \"\\shello\\S\" would send \"shift, h, e, l, l, o, unshift\" and\n");
printf("create the word \"HELLO\"\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Arrow Keys:\n");
printf("    \\u      UP arrow       \n");
printf("    \\d      DOWN arrow       \n");
printf("    \\l      LEFT arrow       \n");
printf("    \\r      RIGHT arrow       \n");
printf("\n");
printf("For example, \"hllo\\l\\l\\le\" would write \"hello\" by writing \"hllo,\"\n");
printf("moving left three characters, and inserting the \"e\" last.\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Special Keys:\n");
printf("    \\b      Backspace\n");
printf("    \\e      Escape\n");
printf("    \\t      Tab\n");
printf("    \\n      Enter/Return\n");
printf("\n");
printf("For example, \"Username\\tPassword\\n\" would type a username, push tab,\n");
printf("type a password, and hit enter.\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Named Keys:\n");
printf("\n");
printf("    \\{F1}       F1 key\n");
printf("    \\{F2}       F2 key\n");
printf("    ...\n");
printf("    \\{F24}      F24 key\n");
printf("    \\{Delete}   Delete\n");
printf("    \\{End}      End\n");
printf("    \\{Home}     Home\n");
printf("    \\{Insert}   Insert\n");
printf("    \\{PgUp}     PageUp\n");
printf("    \\{PgDn}     PageDown\n");
printf("    \\{PrSc}     PrintScreen\n");
printf("    \\{Pause}    Pause\n");
printf("    \\{ScLk}     ScrollLock\n");
printf("\n");
printf("Keys may be abbreviated when unambiguous; delete = \"\\{d}\" etc.\n");
printf("For example, \"\\{pd}\\{pd}\\{e}\" would send PageDown twice, then the \"End\" key.\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Numeric Keypad:\n");
printf("\n");
printf("    \\{n0}       Keypad Zero\n");
printf("    \\{n1}       Keypad One\n");
printf("    ...\n");
printf("    \\{n9}       Keypad Nine\n");
printf("    \\{n*}       Keypad *\n");
printf("    \\{n+}       Keypad +\n");
printf("    \\{n-}       Keypad -\n");
printf("    \\{n/}       Keypad /\n");
printf("    \\{n.}       Keypad .\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Mouse Commands:\n");
printf("\n");
printf("Mouse commands may be given as the special key \"m\" followed by button index,\n");
printf("event, coordinates, and modifiers.  For example, to click the left\n");
printf("mouse button at client-local coordinates (200,100), use this syntax:\n");
printf("\n");
printf("    \\{m,l,click,200,100,local}\n");
printf("\n");
printf("This could also be abbreviated to \"\\{m,l,c,200,100,l}\"\n");
printf("\n");
printf("\"click\" can be replaced with \"down\" or \"up\" if desired.  If the specified\n");
printf("button index is \"wheel\" (or simply \"w\"), then up/down means to roll the wheel\n");
printf("up or down, and \"click\" has no meaning (the wheel as a button is usually\n");
printf("the middle button).  To move the mouse without pressing a button,\n");
printf("specify \"none\" (or \"n\") as the action.  The buttons may be any of the\n");
printf("predefined buttons \"l,\" \"m,\" \"r,\" \"1,\" \"2\" (left, middle, right, extra 1,\n");
printf("extra 2).\n");
printf("\n");
printf("The last option can be \"local\" or \"screen\" (\"l\" or \"s\"), and makes the given\n");
printf("coordinates either local to the client window, or global (to the desktop).\n");
printf("\n");
printf("Some more examples:\n");
printf("\n");
printf("    Press and hold the right mouse button at screen coordinates (100,50):\n");
printf("\n");
printf("       \\{m,r,d,100,50,s}\n");
printf("\n");
printf("    Scroll the mouse wheel up at local coordinates (0,0):\n");
printf("\n");
printf("       \\{m,w,u,0,0,l}\n");
printf("\n");
printf("    Move the mouse to screen coordinates (400,300):\n");
printf("\n");
printf("       \\{m,n,n,400,300,s}\n");
printf("       \n");
printf("Relative movement:\n");
printf("       \n");
printf("    Move the mouse 100 pixels to the right of its current position:\n");
printf("    \n");
printf("       \\{m,n,n,100r,0r,s}\n");
printf("\n");
printf("    Move the mouse 100 pixels up and click the left button:\n");
printf("    \n");
printf("       \\{m,l,c,0r,-100r,s}\n");
printf("\n");
printf("Note:  The mouse cursor is always moved to the selected location prior\n");
printf("       to executing any actions.\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Window Positioning:\n");
printf("\n");
printf("The active window's size and position may be changed as shown in the\n");
printf("following examples:\n");
printf("\n");
printf("    Move the active window to absolute position (200,100) and resize\n");
printf("    it to 640x480:\n");
printf("    \n");
printf("       \\{wp,200,100}\\{ws,640,480}\n");
printf("       \n");
printf("    Move the active window four pixels to the right and two pixels up\n");
printf("    \n");
printf("       \\{wp,4r,-2r}\n");
printf("       \n");
printf("    Resize the current window to 320x240\n");
printf("    \n");
printf("       \\{ws,320,240}\n");
printf("       \n");
printf("    Expand the current window by 100 pixels horizontally\n");
printf("    \n");
printf("       \\{ws,100r,0}\n");
printf("       \n");
printf("Note that a zero window size is simply ignored.  A zero position,\n");
printf("however, indicates the top or left side of the screen.  You may also\n");
printf("place a position and size command in the same string, if you like\n");
printf("(this causes only one MoveWindow call to be made, which may or may\n");
printf("not be important).\n");
printf("\n");
printf("    \\{wp,200,100,640,480}\n");
printf("    \n");
printf("You may use the letters 'h' and 'w' in the numeric portion of the call\n");
printf("to represent the current height and width, respectively, of the Windows\n");
printf("desktop.  The following call would move the window to position (1500,800)\n");
printf("if your desktop resolution is 1600x1200:\n");
printf("\n");
printf("    \\{wp,w-100,h-400}\n");
printf("    \n");
printf("If you use the capital versions of 'H' or 'W' then the value used will be\n");
printf("the \"work area\" dimensions (those of the screen minus the task bar or\n");
printf("other toolbars.\n");
printf("    \n");
printf("(Do not attempt complex mathematics; what you see is about all you get.)\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Windows Messages:\n");
printf("\n");
printf("You may send arbitrary windows messages to the active window during\n");
printf("playback.  the wParam and lParam may be omitted if '0' is desired for their\n");
printf("values.  For example:\n");
printf("\n");
printf("    send notepad \"\\[WM_SYSCOMMAND,SC_MINIMIZE]\"\n");
printf("\n");
printf("will minimize the notepad window.  Note that this will take focus away\n");
printf("from this window and further keystrokes may not be recognized. \n");
printf("Further windows messages, however, will be sent.  Windows message\n");
printf("sending is generally for advanced users, but a few common ones are\n");
printf("listed here for convenience:\n");
printf("\n");
printf("    \\[WM_CLOSE]                     Will close the active window\n");
printf("    \\[WM_SYSCOMMAND,SC_MINIMIZE]    Minimizes the active window\n");
printf("    \\[WM_SYSCOMMAND,SC_MAXIMIZE]    Maximizes the active window\n");
printf("    \\[WM_SYSCOMMAND,SC_RESTORE]     \"Un-minimizes\" the active window\n");
printf("\n");
printf("You may specify decimal or hexadecimal numbers (with the \"0x\" prefix), such\n");
printf("as in the following example:\n");
printf("\n");
printf("    \\[WM_COMMAND,1,0x4007]\n");
printf("\n");
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("Pausing during sending of keystrokes.\n");
printf("\n");
printf("You may have the program pause for a user-specified number of milliseconds\n");
printf("during playback of keystrokes by including \\{sX} in the send string, where\n");
printf("X is an integer.  For example:\n");
printf("\n");
printf("    send notepad \"A\\{s500}B\\{s1000}C\"\n");
printf("\n");
printf("would send the \"A\" key, wait half a second, send the \"B\" key, wait 1\n");
printf("second, and then send the \"C\" key.\n");
printf("\n");
}
